<?php

declare(strict_types=1);

namespace Drupal\dp_clock_mock\Clock;

use DateTimeImmutable as DTI;
use Psr\Clock\ClockInterface;

/**
 * {@selfdoc}
 */
final readonly class FrozenClock implements ClockInterface {

  /**
   * {@selfdoc}
   */
  public function __construct(private string $dateTime) {

  }

  /**
   * {@inheritdoc}
   */
  public function now(): DTI {
    return new DTI($this->dateTime);
  }

}
