<?php

declare(strict_types=1);

namespace Drupal\dp_clock_mock\Clock;

use DateTimeImmutable as DTI;
use Psr\Clock\ClockInterface;

/**
 * {@selfdoc}
 */
final class MemoryClock implements ClockInterface, ClockHandlerInterface {

  /**
   * {@selfdoc}
   */
  private string $timestamp = 'now';

  /**
   * {@inheritdoc}
   */
  public function now(): DTI {
    return new DTI($this->get());
  }

  /**
   * {@inheritdoc}
   */
  public function set(string $timestamp): self {
    $this->timestamp = $timestamp;
    return $this;
  }

  /**
   * {@inheritdoc}
   */
  public function get(): string {
    return $this->timestamp;
  }

  /**
   * {@inheritdoc}
   */
  public function reset(): self {
    return $this->set('now');
  }

}
