<?php

declare(strict_types=1);

namespace Drupal\dp_clock_mock;

use Drupal\Core\DependencyInjection\ContainerBuilder;
use Drupal\Core\DependencyInjection\ServiceModifierInterface;
use Drupal\Core\State\StateInterface;

/**
 * Defines a service provider for the Clock Mock module.
 */
final class DpClockMockServiceProvider implements ServiceModifierInterface {

  public const string CLOCK_MOCK_ID = 'dp_clock_mock';

  /**
   * {@inheritdoc}
   */
  public function alter(ContainerBuilder $container): void {
    $state = $container->get('state');
    \assert($state instanceof StateInterface);
    // If clock mock is not set leave the clock with default implementation.
    if ($clock_mock = $state->get(self::CLOCK_MOCK_ID)) {
      $container->setAlias('date_point.clock', $clock_mock);
    }
  }

}
