<?php

declare(strict_types=1);

namespace Drupal\Tests\date_point\Kernel;

use DateTimeImmutable as DTI;
use Drupal\KernelTests\KernelTestBase;
use Psr\Clock\ClockInterface;

/**
 * A test for a clock service.
 *
 * @group date_point
 */
final class ClockTest extends KernelTestBase {

  /**
   * {@inheritdoc}
   */
  protected static $modules = ['date_point'];

  /**
   * {@selfdoc}
   */
  public function testClock(): void {
    $clock = $this->container->get('date_point.clock');
    \assert($clock instanceof ClockInterface);
    self::assertInstanceOf(DTI::class, $clock->now());
    // Assert that now() points to the current time.
    self::assertContains(\time() - $clock->now()->getTimestamp(), [0, 1]);
  }

}
